/*	
 *	main.c
 *
 *	s3mplay - rRlvC[
 *	Copyright (C) 2002 Naoyuki Sawa
 *
 *	* Sun Oct 6 12:00:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 *	* Mon Oct 7 12:15:00 JST 2002 Naoyuki Sawa
 *	- ʂQ{ER{[hł̉ጸB(mod.c:startplayingC)
 *	- ꂪ̂ŁAʂX{[h܂ŊgB(LOUDNESS_MAXύX)
 *	* Tue Oct 8 12:30:00 JST 2002 Naoyuki Sawa
 *	- Tvf[^ROMɒu悤ɕύXB
 *	  ɔāAS3MTv͈͕̔ύX́AڃTvf[^
 *	  ̂łȂA{[e[uVtg悤ɕύXB
 *	- p^[f[^ROMɒu悤ɕύXB
 *	- malloc/freesvɂȂ̂ŁAq[v֐폜B
 *	- t[`play_mod()GoOĂ̂CB
 *	  SecondRealityœrI`ɂȂ肪܂B
 *	- TEhobt@ămCYĂ悤ł̂ŁA
 *	  TEhobt@5121024KBɑ₵܂B
 *	* Wed Oct 9 00:00:00 JST 2002 Naoyuki Sawa
 *	- {CXꕔ̊y킪ĂȂ̂CB
 *        Xmixspeeduint16ϐ̂ɁAgŒɂƂ
 *        PɁu16000vƂĂ܂̂łBił͕tj
 *        Z҂ꕔ̊֐Ŗ肪Ă܂B
 *        main.hmixspeed`̂Ƃ̃RgQƂĂB
 *	* Mon Oct 21 00:00:00 JST 2002 Naoyuki Sawa
 *	- play.c,mix.c,s3m.cRAMɓ]č܂B
 *	  ̑ɁAX^bNSRAMɈړ܂B
 */
#include "main.h"

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define CH		0		/* Đ`l */
#define ATT		0		/* `lʌ */
#define MAX_FILES	MAXDIR		/* őt@C */
#define MAX_DISP	7		/* Sɕ\łt@C */
#define LOUDNESS_MAX	(9-1)		/* ʒ̍ől */

/****************************************************************************
 *	O[oϐ
 ****************************************************************************/

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */
int errno;				/* bWCug߂ɕKv */
char* err;				/* G[͂ɃbZ[WZbg */
int recover;				/* A\ȃG[H */
char files[MAX_FILES][32];		/* MOD/S3Mt@CXg */
int n_files;				/* MOD/S3Mt@C */
int cursel;				/* ݂̑It@CCfNX */
int curtop;				/* ŏi\t@CCfNX */
int loudness;				/* 0:ʏ/1:ʓ{/2:ʎO{... */

/****************************************************************************
 *	֐錾
 ****************************************************************************/

static int s3m_play(int ch, const char* fname);
static void s3m_stop();

/****************************************************************************
 *	pceAppInit
 ****************************************************************************/

void
pceAppInit()
{
	int retval, len;
	FILEINFO fi;

	/* RAMւ̃R[h̃Rs[B
	 * RAMɃRs[ŏ̃W[AMakefileƈv邱ƁI
	 * * ]W[̃V{́A+addr{}Ɏw肵Ȃ`܂B
	 *   ̏ꍇA__START_FRAMCƂ__SIZEOF_FRAMC͒`Ȃ̂łB
	 *   dȂ̂ŁA]TCY͓]ZNV__SIZEOF_𗘗p܂B
	 *   ]ZNV̐擪AhX́Aŏ̓]W[̐擪AhX𗘗p܂B
	 * * FRAMCɗ񋓂W[AĔzuۏ؂܂B
	 *   OBJSɗ񋓂ʂɔzu܂B
	 *   Ⴆ΁A
	 *	OBJS=a.o b.o c.o d.o
	 *   ŁA
	 *	+codeblock FRAMC {a.o b.o. d.o}
	 *   ƂꍇAROM̔zu a.o b.o c.o d.o ƂȂĂ܂̂łB
	 *   RAMɓ]郂W[̕т́AOBJS̕тɈvĂȂ΂܂I
	 *   L̗Ȃ΁AOBJS
	 *	OBJS=a.o b.o d.o c.o
	 *   ƕς΁AROMł a.o b.o d.o AĔzu܂B
	 */
	{
		extern unsigned char __START_V_FRAMC[];
		extern unsigned char __END_V_FRAMC[];
		extern unsigned char __START_play_code[]; /* RAMɃRs[ŏ̃W[ */
		memcpy(__START_V_FRAMC,
		       __START_play_code,
		       __END_V_FRAMC - __START_V_FRAMC);
	}

	/* ʓIȏB */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceAppSetProcPeriod(100);
	pceLCDDispStart();

	/* MOD/S3Mt@CT܂B */
	retval = pceFileFindOpen(&fi);
	if(retval != 0) {
		err = "pceFileFindOpen failed";
		recover = 0;
		return;
	}
	while(n_files < MAX_FILES) {
		retval = pceFileFindNext(&fi);
		if(!retval) break; /* Ȃ */
		if((len = strlen(fi.filename)) < 4) continue;
		if(strcmp(&fi.filename[len - 4], ".mod") == 0 ||
		   strcmp(&fi.filename[len - 4], ".s3m") == 0) {
			strcpy(files[n_files++], fi.filename);
		}
	}
	pceFileFindClose(&fi);
	if(n_files == 0) {
		/*     OPQRSTUVWXOPQ */
		err = "MOD/S3M̧ق܂";
		recover = 0;
		return;
	}

	/* `lʌݒ肵܂B */
	pceWaveSetChAtt(CH, ATT);
}

/****************************************************************************
 *	pceAppProc
 ****************************************************************************/

void
pceAppProc(int count)
{
	int retval, pad, i, x, y;

	/* ɃX^oCɗȂ悤ɁB */
	pceAppActiveResponse(AAR_ACTIVE);

	/* pbhԎ擾ASELECT{^ŏIB */
	pad = pcePadGet();
	if(pad & TRG_SELECT) {
		pceAppReqExit(0);
		return;
	}

	/* ʃNAB */
	memset(vbuff, 0, sizeof vbuff);

	if(err != NULL) {
		/* G[bZ[W\B */
		pceFontSetType(0x80);
		pceFontSetTxColor(3);
		pceFontSetBkColor(-1);
		pceFontSetPos(0, 0);
		pceFontPutStr(err);

		/* G[H */
		if(recover) {
			if(pad & (TRG_A | TRG_B)) err = NULL;
		}

	} else {
		/* t@CIύXB */
		if(pad & TRG_UP && 0 < cursel) cursel--;
		if(pad & TRG_DN && cursel < n_files - 1) cursel++;
		if(cursel < curtop                 ) curtop = cursel                 ;
		if(cursel > curtop + (MAX_DISP - 1)) curtop = cursel - (MAX_DISP - 1);

		/* EhlXύXB */
		if(pad & TRG_START) {
DISABLE;
			if(++loudness > LOUDNESS_MAX) loudness = 0;
ENABLE;
		}

		/* ĐJnH */
		if(pad & TRG_A) {
			retval = s3m_play(CH, files[cursel]);
			if(retval != 0) {
				if(err == NULL) err = "Đł܂ł";
				recover = 1;
			}
		}

		/* Đ~H */
		if(pad & TRG_B) s3m_stop();

		/* t@CXg\B */
		pceFontSetType(0x80);
		for(i = 0; i < n_files; i++) {
			x = 5;
			y = 14 + (i - curtop) * 10;
			if(i == cursel) {
				pceFontSetTxColor(0);
				pceFontSetBkColor(2);
			} else {
				pceFontSetTxColor(3);
				pceFontSetBkColor(-1);
			}
			pceFontSetPos(x, y);
			pceFontPutStr(files[i]);
			y += 10;
		}

		/* ^Cg\Biɂ͂ݏot@CXgɏ㏑j */
		pceFontSetType(0x80);
		pceFontSetTxColor(0);
		pceFontSetBkColor(3);
		x = (DISP_X - 10 * 13) / 2;
		y = 0;
		pceFontSetPos(x, y);
		/*             OPQRSTUVWXOPQ*/
		pceFontPutStr("=====rRlvC[=====");

		/* EhlX\B */
		if(loudness) {
			pceFontSetType(0x82);
			pceFontSetTxColor(2);
			pceFontSetBkColor(0);
			x = DISP_X - 4 * 2;
			y = DISP_Y - 6;
			pceFontSetPos(x, y);
			pceFontPrintf("%dx", loudness + 1);
		}
	}

	/* ʓ]B */
	pceLCDTrans();
}

/****************************************************************************
 *	pceAppExit
 ****************************************************************************/

void
pceAppExit()
{
	/* mɍĐ~B */
	s3m_stop();
}

/****************************************************************************
 *	s3modpɓt@C֐
 ****************************************************************************/

#define BLOCKSIZE	0x1000	/* P/ECEtbVZN^TCY       */
static FILEACC file_acc;	/* t@CANZX\(Popen̂!) */
static int file_pos;		/* JĂt@C̓ǂݍ݈ʒu      */

FILE*
fopen(const char* fname, const char* mode)
{
	FILEACC* fa = &file_acc;
	int retval;

	retval = pceFileOpen(fa, fname, FOMD_RD);
	if(retval != 0) return NULL;
	file_pos = 0; /* YȂŁI */

	return (FILE*)fa;
}

int
fclose(FILE* fp)
{
	FILEACC* fa = (FILEACC*)fp;
	int retval;

	retval = pceFileClose(fa);
	if(retval != 0) return -1;

	return 0;
}

size_t
fread(void* buf, size_t size, size_t count, FILE* fp)
{
	FILEACC* fa = (FILEACC*)fp;
	char* p = (char*)buf;
	int len = size * count;
	int i, sct, sof, sln;

	i = 0;
	while(i < len) {
		/* ZN^̃tbVAhX擾܂B */
		sct = (file_pos + i) / BLOCKSIZE;		/* sct = ݂̓ǂݍ݃ItZbg܂ރZN^ԍ                         */
		sln = pceFileReadSct(fa, NULL, sct, BLOCKSIZE);	/* sln = ̃ZN^̃f[^TCY(ŏIZN^̂sln<=BLOCKSIZEɂȂ܂) */
		if(sln == 0) break;				/* ԂItZbg                                                   */

		/* ̃ZN^ǂݍރTCY肵܂B */
		sof = (file_pos + i) % BLOCKSIZE;		/* ZN^ItZbg                                                       */
		sln -= sof;					/* ZN^ItZbgȍ~ǂݍ݉\ȍőf[^TCY                 */
		if(sln > len - i) sln = len - i;		/* ǂݍ݉\ȍőf[^TCYcǂݍ݃TCYȏȂA؂l߂܂ */
		if(sln <= 0) break;				/* ԂItZbg߁A܂͓ǂݍ݃TCY0ȉw肳ꂽ(len<=0)    */

		/* ZN^obt@֓ǂݍ݂܂B */
		memcpy(p + i, fa->aptr + sof, sln);
		i += sln;
	}
	file_pos += i; /* YȂŁI */

	return i / size; /* size[byte]Pʂœǂ߂̂Ɖ */
}

int
fseek(FILE* fp, long offset, int whence)
{
	switch(whence) {
	case SEEK_SET:
		file_pos = offset;
		break;
	case SEEK_CUR:
		file_pos += offset;
		break;
	case SEEK_END:
		file_pos = file_acc.fsize - offset;
		break;
	default:
		return -1;
	}

	return 0;
}

/* ݂̃t@Cǂݍ݈ʒuROMAhXԂ܂B
 * G[`FbN͍sĂ܂B
 */
void*
fread_rom(size_t size, size_t count, FILE* fp)
{
	FILEACC* fa = (FILEACC*)fp;
	char* ptr;

	pceFileReadSct(fa, NULL, file_pos / BLOCKSIZE, BLOCKSIZE);
	ptr = (char*)fa->aptr + file_pos % BLOCKSIZE; /* ZN^ItZbĝYꂸ! */
	file_pos += size * count;

	return ptr;
}

/****************************************************************************
 *	S3Mt[`
 ****************************************************************************/

#define TRAP_HSDMA1	23	/* DMA Ch.1]I荞݃xN^ԍ   */
#define MAXCH		4	/* `lFP/ECEdl                    */
#define BLKN		2	/* ubNFA2ȏBԂ2ŏ[ */
//#define BLKS		512	/* ubNTCY(Tv)FA64xN */
//512ł͊ԂɍȂďmCY邱Ƃ݂Ȃ̂ŁA傫܂
#define BLKS		1024	/* ubNTCY(Tv)FA64xN */
#define SAMPLERATE	16000	/* WAVEf[^̃Tv[g               */

typedef struct _S3MINFO {
	PCEKSENT old_isr;	/* +0,4:̃TEh荞݃[`       */
	volatile char busy;	/* +4,1:s3m_fill()ē֎~tO           */
	volatile char bc;	/* +5,1:󂫃ubN                     */
	         char bi;	/* +6,1:󂫃ubN̐擪CfNX       */
	         char ch;	/* +7,1:Đ`l                       */
	/* Wave֘A */
	PCEWAVEINFO wi[BLKN];	/* WAVEwb_   */
	short wb[BLKN][BLKS];	/* WAVEf[^   */
} S3MINFO;
static S3MINFO s3m_info;

static void s3m_isr();
static void s3m_fill();
static void s3m_fill_busy();
static void s3m_endproc(PCEWAVEINFO* wi);

int
s3m_play(int ch, const char* fname)
{
	S3MINFO* si = &s3m_info;

	int retval, i, len, ofs;
	const unsigned char* ptr;
	PCEWAVEINFO* wi;
	FILEACC fa;

	/* mɒ~܂B */
	s3m_stop();

	/* ŜNA܂B */
	memset(si, 0, sizeof(S3MINFO));

	/* Đ`li[܂B */
	if(ch < 0 || MAXCH - 1 < ch) {
		err = "Đ`lsł";
		return -1;
	}
	si->ch = ch;

	/* ZN^AĂ邱ƂmF܂B */
	retval = pceFileOpen(&fa, fname, FOMD_RD);
	if(retval != 0) {
		err = "t@CJ܂";
		return -1;
	}
	ptr = NULL; /* x} */
	for(ofs = 0; ofs < fa.fsize; ofs += BLOCKSIZE) {
		pceFileReadSct(&fa, NULL, ofs / BLOCKSIZE, BLOCKSIZE);
		if(ofs != 0) { /* 擪ZN^ȊO... */
			/* ÕZN^BLOCKSIZE[byte]ł邱ƁB */
			if(fa.aptr != ptr + BLOCKSIZE) {
				pceFileClose(&fa);
				err = "t@CsAł\n"
				      "xt@CS\n"
				      "]Ă݂Ă";
				return -1;
			}
		}
		/* ̌̂߂ɁÃZN^̃AhXLB */
		ptr = fa.aptr;
	}
	pceFileClose(&fa); /* load_mod/s3m̒ł炽߂Open܂ */

	/* MOD/S3Mt@C[h܂B */
	retval = -1;
	if((len = strlen(fname)) >= 4) {
		       if(strcmp(&fname[len - 4], ".mod") == 0) {
			retval = load_mod((char*)fname, &mod);
		} else if(strcmp(&fname[len - 4], ".s3m") == 0) {
			retval = load_s3m((char*)fname, &mod);
		}
	}
	if(retval != 0) {
		err = "̧ٓǂݍ݂Ɏs܂";
		return -1;
	}

	/* ĐJnB */
	startplaying(1); /* 0:normal/1:loudness炵ǁA܂ςȂ */

	/* WAVE܂B */
	for(i = 0, wi = si->wi; i < BLKN; i++, wi++) {
		wi->type = PW_TYPE_16BITPCM; /* ւɂ̂PW_TYPE_CONTsv */
		wi->pData = &si->wb[i][0];
		wi->len = BLKS;
		wi->next = &si->wi[(i + 1) % BLKN]; /* ւɂ܂ */
		wi->pfEndProc = s3m_endproc;
	}

	/* ĐJnOɁASubNɃf[^𖞂Ă܂B */
	si->bc = BLKN;
	s3m_fill();
	s3m_fill_busy(); /* RpČx} */

	/* TEh荞݃[`tbNAWaveĐJn܂B
	 * ̓̊ԂɃTEh荞݂Ă͂܂B
	 */
DISABLE;
	si->old_isr = pceVectorSetTrap(TRAP_HSDMA1, s3m_isr);
	pceWaveDataOut(si->ch, &si->wi[0]);
ENABLE;

	return 0;
}

void
s3m_stop()
{
	S3MINFO* si = &s3m_info;

	/* ĐłȂΉ܂B */
	if(si->old_isr == NULL) return;

	/* WAVEĐ~ATEh荞݃[`ɖ߂܂B
	 * ̓̊ԂɃTEh荞݂Ă͂܂B
	 */
DISABLE;
	pceWaveAbort(si->ch);
	pceVectorSetTrap(TRAP_HSDMA1, si->old_isr);
	si->old_isr = NULL;
ENABLE;
}

static void
s3m_isr()
{
	/* [%sp+ 0]:psr
	 * [%sp+ 1]:pc
	 */
	asm("
	pushn %r15
	ld.w %r0, %alr
	ld.w %r1, %ahr
	pushn %r1
	");
	/* [%sp+ 0]:alr
	 * [%sp+ 1]:ahr
	 * [%sp+ 2]:r0
	 * [%sp+ 3]:r1
	 * [%sp+ 4]:r2
	 * [%sp+ 5]:r3
	 * [%sp+ 6]:r4
	 * [%sp+ 7]:r5
	 * [%sp+ 8]:r6
	 * [%sp+ 9]:r7
	 * [%sp+10]:r8
	 * [%sp+11]:r9
	 * [%sp+12]:r10
	 * [%sp+13]:r11
	 * [%sp+14]:r12
	 * [%sp+15]:r13
	 * [%sp+16]:r14
	 * [%sp+17]:r15
	 * [%sp+18]:psr
	 * [%sp+19]:pc
	 */
	asm("
	 ld.w %r0, [%sp+18]		; psr
	xld.w %r3, s3m_info
	 ld.w %r4, [%r3]+		; old_isr
	xld.w %r1, s3m_fill_busy
	xld.w %r2, s3m_isr_ret_busy
	btst [%r3], 0			; busy?
	jrne s3m_isr_busy
	xld.w %r1, s3m_fill
	xld.w %r2, s3m_isr_ret
	bset [%r3], 0			; busy <- 1
s3m_isr_busy:
	pushn %r2
	");
	/* %r3     :&busy
	 * %r4     :old_isr
	 * [%sp+ 0]:psr
	 * [%sp+ 1]:s3m_fill/busy
	 * [%sp+ 2]:s3m_isr_ret/busy
	 * [%sp+ 3]:alr
	 * [%sp+ 4]:ahr
	 * [%sp+ 5]:r0
	 * [%sp+ 6]:r1
	 * [%sp+ 7]:r2
	 * [%sp+ 8]:r3
	 * [%sp+ 9]:r4
	 * [%sp+10]:r5
	 * [%sp+11]:r6
	 * [%sp+12]:r7
	 * [%sp+13]:r8
	 * [%sp+14]:r9
	 * [%sp+15]:r10
	 * [%sp+16]:r11
	 * [%sp+17]:r12
	 * [%sp+18]:r13
	 * [%sp+19]:r14
	 * [%sp+20]:r15
	 * [%sp+21]:psr
	 * [%sp+22]:pc
	 */
	asm("
	jp %r4				; * old_isr->(iret)->s3m_fill/busy->(ret)->s3m_isr_ret/busy
					;   Ԃ̊荞݋֎~h߁Aold_isrretiƂ
					;   荞ݔpsr(ĂIE=1)𕜌Ă܂B
					; * 荞݃[`ł̓tOۑKv̂ŁA
					;   s3m_isrAƂretł͂ȂretigȂ΂܂B
					;   ܂A荞ݔpsrA񕜌Ă܂B
s3m_isr_ret:
	bclr [%r3], 0			; S1C33̊֐KɂAr3͕ێĂ͂B
s3m_isr_ret_busy:
	");
	/* [%sp+ 0]:alr
	 * [%sp+ 1]:ahr
	 * [%sp+ 2]:r0
	 * [%sp+ 3]:r1
	 * [%sp+ 4]:r2
	 * [%sp+ 5]:r3
	 * [%sp+ 6]:r4
	 * [%sp+ 7]:r5
	 * [%sp+ 8]:r6
	 * [%sp+ 9]:r7
	 * [%sp+10]:r8
	 * [%sp+11]:r9
	 * [%sp+12]:r10
	 * [%sp+13]:r11
	 * [%sp+14]:r12
	 * [%sp+15]:r13
	 * [%sp+16]:r14
	 * [%sp+17]:r15
	 * [%sp+18]:psr
	 * [%sp+19]:pc
	 */
	asm("
	popn %r1
	ld.w %ahr, %r1
	ld.w %alr, %r0
	popn %r15
	");
	/* [%sp+ 0]:psr
	 * [%sp+ 1]:pc
	 */
	asm("
	reti
	");
}

static void
s3m_fill()
{
	S3MINFO* si = &s3m_info;

	while(si->bc != 0) {
		/* S3Mf[^WJ܂B */
		play_mod(si->wb[(int)si->bi], BLKS);

		/* 󂫃ubN̐擪CfNXi߂܂B */
		if(++si->bi == BLKN) si->bi = 0;

		/* 󂫃ubN炵܂B
		 * * s3m_fill()s3m_endproc()Ɋ荞܂\̂ŁA
		 *   u󂫃ubN擾1炷i[v̏̑OŊ荞ݐ䂪KvłB
		 * * s3m_isr()oRł̊֐Ă΂ꂽ́A荞݋Ԃ͕sȂ̂ŁA
		 *   PDISABLE/ENABLEł͂ȂAԑޔE֎~EsKv܂B
		 * * 悭lAs3m_isr()oRŌĂ΂ꂽ́A荞݋Ɍ܂Ă悤ȋCĂ܂B
		 *   s3m_isr()͍DMÅ荞݃nhȂ̂łA
		 *   s3m_isr()Ă΂ꂽDMÅ荞݂ꂽ荞݂ĂB
		 * * Ƃ킯ŁAPDISABLE/ENABLEłvm܂B
		 *   ܂AԑޔE֎~EmAȂƂQ͂Ȃ̂ŁÂ܂܂ɂĂ܂B
		 */
		asm("
		pushn %r2
		ld.w %r0, %psr			; %psrۑ
		xand %r1, %r0, 0xffffffef	; 荞݋֎~
		ld.w %psr, %r1
		xld.w %r1, s3m_info + 5		; s3m_info.bc--
		ld.b %r2, [%r1]
		sub %r2, 1
		ld.b [%r1], %r2
		ld.w %psr, %r0			; %psr
		popn %r2
		");
	}
}

static void
s3m_fill_busy()
{
	/* ܂B */
}

static void
s3m_endproc(PCEWAVEINFO* wi)
{
	S3MINFO* si = &s3m_info;

	/* 󂫃ubN𑝂₵܂B
	 * * PCEWAVEINFO.pfEndProc͊荞݋ԂŌĂ΂܂A
	 *   TEhhCoɂčē֎~Ă̂ŁA
	 *   usi->bc++v̑Oł̊荞ݐ͕Kv܂B
	 * * ē֎~́Asound_isr3()̌㔼ōsĂ܂B
	 *   isnd.c 421`430sQƁABIOS 1.18݁j
	 */
	si->bc++;
}
